* configure.in: Remove uses of config/mh-linux.
[binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils"
53
54
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
57 #
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
63 #
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
67 #
68 target_tools="target-examples target-groff"
69
70 ################################################################################
71
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
77
78 # directories to be built in the native environment only
79 #
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84 # directories to be built in a cross environment only
85 #
86 cross_only="target-libiberty target-libgloss target-newlib"
87
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
93 #
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
96
97 ################################################################################
98
99 srctrigger=move-if-change
100 srcname="gnu development package"
101
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
104
105 # per-host:
106
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
114 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
115 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
116 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
117 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
118 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
119 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
120 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
121 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
122 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
123 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
124 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
125 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
126 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
127 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
128 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
129 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
130 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
132 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
133 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
134 *-windows*) host_makefile_frag=config/mh-windows ;;
135 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
136 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
137 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
138 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
139 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
140 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
141 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
142 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
143 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
144 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
145 esac
146 fi
147
148 # If we aren't going to be using gcc, see if we can extract a definition
149 # of CC from the fragment.
150 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
151 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
152 found=
153 for dir in $PATH; do
154 test -z "$dir" && dir=.
155 if test -f $dir/gcc; then
156 found=yes
157 break
158 fi
159 done
160 IFS="$save_ifs"
161 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
162 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
163 if [ -n "${xx}" ] ; then
164 CC=$xx
165 fi
166 fi
167 fi
168
169 # We default to --with-shared on platforms where -fpic is meaningless.
170 # Well, we don't yet, but we will.
171 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
172 case "${target}" in
173 alpha-dec-osf*) enable_shared=yes ;;
174 alpha-*-linux*) enable_shared=yes ;;
175 mips-sgi-irix5*) enable_shared=yes ;;
176 *) enable_shared=no ;;
177 esac
178 fi
179
180 case "${enable_shared}" in
181 yes) shared=yes ;;
182 no) shared=no ;;
183 "") shared=no ;;
184 *) shared=yes ;;
185 esac
186
187 if [ x${shared} = xyes ]; then
188 waugh=
189 case "${host}" in
190 hppa*) waugh=config/mh-papic ;;
191 i[3456]86-*) waugh=config/mh-x86pic ;;
192 sparc64-*) waugh=config/mh-sparcpic ;;
193 *) waugh=config/mh-${host_cpu}pic ;;
194 esac
195 if [ -f ${srcdir}/${waugh} ]; then
196 if [ -n "${host_makefile_frag}" ] ; then
197 cat ${srcdir}/${host_makefile_frag} > mh-frag
198 cat ${srcdir}/${waugh} >> mh-frag
199 host_makefile_frag=mh-frag
200 else
201 host_makefile_frag=${waugh}
202 fi
203 fi
204 fi
205
206 # per-target:
207
208 case "${target}" in
209 v810*) target_makefile_frag=config/mt-v810 ;;
210 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
211 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
212 esac
213
214 skipdirs=
215 gasdir=gas
216 use_gnu_ld=
217 use_gnu_as=
218
219 # some tools are so dependent upon X11 that if we're not building with X,
220 # it's not even worth trying to configure, much less build, that tool.
221
222 case ${with_x} in
223 yes | "") # the default value for this tree is that X11 is available
224 ;;
225 no)
226 skipdirs="${skipdirs} tk gash"
227 ;;
228 *)
229 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
230 ;;
231 esac
232
233 # Some tools are only suitable for building in a "native" situation.
234 # Those are added when we have a host==target configuration. For cross
235 # toolchains, we add some directories that should only be useful in a
236 # cross-compiler.
237
238 is_cross_compiler=
239
240 if [ x"${host}" = x"${target}" ] ; then
241 # when doing a native toolchain, don't build the targets
242 # that are in the 'cross only' list
243 skipdirs="${skipdirs} ${cross_only}"
244 is_cross_compiler=no
245 target_subdir=.
246 else
247 # similarly, don't build the targets in the 'native only'
248 # list when building a cross compiler
249 skipdirs="${skipdirs} ${native_only}"
250 is_cross_compiler=yes
251 target_subdir=${target_alias}
252 if [ ! -d ${target_subdir} ] ; then
253 if mkdir ${target_subdir} ; then true
254 else
255 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
256 exit 1
257 fi
258 fi
259 fi
260
261 copy_dirs=
262
263 # Handle --with-headers=XXX. The contents of the named directory are
264 # copied to $(tooldir)/sys-include.
265 if [ x"${with_headers}" != x ]; then
266 if [ x${is_cross_compiler} = xno ]; then
267 echo 1>&2 '***' --with-headers is only supported when cross compiling
268 exit 1
269 fi
270 case "${exec_prefixoption}" in
271 "") x=${prefix} ;;
272 *) x=${exec_prefix} ;;
273 esac
274 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
275 fi
276
277 # Handle --with-libs=XXX. Multiple directories are permitted. The
278 # contents are copied to $(tooldir)/lib.
279 if [ x"${with_libs}" != x ]; then
280 if [ x${is_cross_compiler} = xno ]; then
281 echo 1>&2 '***' --with-libs is only supported when cross compiling
282 exit 1
283 fi
284 # Copy the libraries in reverse order, so that files in the first named
285 # library override files in subsequent libraries.
286 case "${exec_prefixoption}" in
287 "") x=${prefix} ;;
288 *) x=${exec_prefix} ;;
289 esac
290 for l in ${with_libs}; do
291 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
292 done
293 fi
294
295 # If both --with-headers and --with-libs are specified, default to
296 # --without-newlib.
297 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
298 if [ x"${with_newlib}" = x ]; then
299 with_newlib=no
300 fi
301 fi
302
303 # Recognize --with-newlib/--without-newlib.
304 if [ x${with_newlib} = xno ]; then
305 skipdirs="${skipdirs} target-newlib"
306 elif [ x${with_newlib} = xyes ]; then
307 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
308 fi
309
310 # Default to using --with-stabs for certain targets.
311 if [ x${with_stabs} = x ]; then
312 case "${target}" in
313 mips*-*-irix6*)
314 ;;
315 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
316 with_stabs=yes;
317 withoptions="${withoptions} --with-stabs"
318 ;;
319 esac
320 fi
321
322 # Handle ${copy_dirs}
323 set fnord ${copy_dirs}
324 shift
325 while [ $# != 0 ]; do
326 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
327 :
328 else
329 echo Copying $1 to $2
330
331 # Use the install script to create the directory and all required
332 # parent directories.
333 if [ -d $2 ]; then
334 :
335 else
336 echo >config.temp
337 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
338 fi
339
340 # Copy the directory, assuming we have tar.
341 # FIXME: Should we use B in the second tar? Not all systems support it.
342 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
343
344 # It is the responsibility of the user to correctly adjust all
345 # symlinks. If somebody can figure out how to handle them correctly
346 # here, feel free to add the code.
347
348 echo $1 > $2/COPIED
349 fi
350 shift; shift
351 done
352
353 # Configure extra directories which are host specific
354
355 case "${host}" in
356 i[3456]86-*-go32*)
357 configdirs="$configdirs dosrel" ;;
358 *-cygwin32*)
359 configdirs="$configdirs dosrel" ;;
360 esac
361
362 # Remove more programs from consideration, based on the host or
363 # target this usually means that a port of the program doesn't
364 # exist yet.
365
366 noconfigdirs=""
367
368 case "${host}" in
369 i[3456]86-*-vsta)
370 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
371 ;;
372 i[3456]86-*-go32)
373 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 *-*-cygwin32)
376 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
377 ;;
378 *-*-windows*)
379 # This is only used to build WinGDB...
380 configdirs="bfd gdb libiberty opcodes readline sim"
381 target_configdirs=
382 ;;
383 ppc*-*-pe)
384 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
385 ;;
386 esac
387
388
389 case "${target}" in
390 *-*-netware)
391 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
392 ;;
393 *-*-vxworks*)
394 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
395 ;;
396 alpha-dec-osf*)
397 # ld works, but does not support shared libraries. emacs doesn't
398 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
399 # gas doesn't generate exception information.
400 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
401 ;;
402 alpha*-*-*vms*)
403 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
404 ;;
405 alpha*-*-*)
406 # newlib is not 64 bit ready
407 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
408 ;;
409 # start-sanitize-arc
410 arc-*-*)
411 noconfigdirs="$noconfigdirs target-libgloss"
412 ;;
413 # end-sanitize-arc
414 arm-*-pe*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 arm-*-coff*)
418 noconfigdirs="$noconfigdirs target-libgloss"
419 ;;
420 arm-*-riscix*)
421 noconfigdirs="$noconfigdirs ld target-libgloss"
422 ;;
423 # start-sanitize-d10v
424 d10v-*-*)
425 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
426 ;;
427 # end-sanitize-d10v
428 h8300*-*-* | \
429 h8500-*-*)
430 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
431 ;;
432 hppa*-*-*elf* | \
433 hppa*-*-lites*)
434 # Do configure ld/binutils/gas for this case.
435 ;;
436 hppa*-*-*)
437 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
438 # cc is gcc, and on any system a user should be able to link cc to
439 # whatever they want. FIXME, emacs emacs19).
440 case "${CC}" in
441 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
442 *) ;;
443 esac
444 noconfigdirs="$noconfigdirs ld shellutils"
445 ;;
446 i[3456]86-*-go32)
447 # but don't build gdb
448 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
449 ;;
450 *-*-cygwin32)
451 target_configdirs="$target_configdirs target-winsup"
452 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
453 # always build newlib.
454 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
455
456 # Can't build gdb for cygwin32 if not native.
457 case "${host}" in
458 *-*-cygwin32) ;; # keep gdb
459 *) noconfigdirs="$noconfigdirs gdb"
460 esac
461 ;;
462 i[3456]86-*-pe)
463 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
464 ;;
465 i[3456]86-*-sco3.2v5*)
466 # The linker does not yet know about weak symbols in COFF,
467 # and is not configured to handle mixed ELF and COFF.
468 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
469 ;;
470 i[3456]86-*-sco*)
471 noconfigdirs="$noconfigdirs gprof target-libgloss"
472 ;;
473 i[3456]86-*-solaris2*)
474 # The linker does static linking correctly, but the Solaris C library
475 # has bugs such that some important functions won't work when statically
476 # linked. (See man pages for getpwuid, for example.)
477 noconfigdirs="$noconfigdirs ld target-libgloss"
478 ;;
479 i[3456]86-*-sysv4*)
480 # The SYSV4 C compiler doesn't handle Emacs correctly
481 case "${CC}" in
482 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
483 *) ;;
484 esac
485 # but that's okay since emacs doesn't work anyway
486 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
487 ;;
488 mn10200-*-*)
489 noconfigdirs="$noconfigdirs gdb target-libgloss"
490 ;;
491 mn10300-*-*)
492 noconfigdirs="$noconfigdirs target-libgloss"
493 ;;
494 powerpc-*-aix*)
495 # copied from rs6000-*-* entry
496 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
497 # This is needed until gcc and ld are fixed to work together.
498 use_gnu_ld=no
499 ;;
500 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
501 target_configdirs="$target_configdirs target-winsup"
502 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
503 # always build newlib.
504 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
505 ;;
506 # This is temporary until we can link against shared libraries
507 powerpcle-*-solaris*)
508 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
509 ;;
510 rs6000-*-lynxos*)
511 # The CVS server code doesn't work on the RS/6000
512 # Newlib makes problems for libg++ in crosses.
513 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
514 ;;
515 rs6000-*-aix*)
516 noconfigdirs="$noconfigdirs gprof"
517 # This is needed until gcc and ld are fixed to work together.
518 use_gnu_ld=no
519 ;;
520 rs6000-*-*)
521 noconfigdirs="$noconfigdirs gprof"
522 ;;
523 m68k-apollo-*)
524 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
525 ;;
526 mips*-*-irix5*)
527 # The GNU linker does not support shared libraries.
528 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
529 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
530 ;;
531 mips*-*-irix6*)
532 # The GNU linker does not support shared libraries.
533 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
534 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
535 ;;
536 mips*-dec-bsd*)
537 noconfigdirs="$noconfigdirs gprof target-libgloss"
538 ;;
539 mips*-*-bsd*)
540 noconfigdirs="$noconfigdirs gprof target-libgloss"
541 ;;
542 mips*-*-*)
543 noconfigdirs="$noconfigdirs gprof"
544 ;;
545 romp-*-*)
546 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
547 ;;
548 sh-*-*)
549 case "${host}" in
550 i[3456]86-*-vsta) ;; # don't add gprof back in
551 i[3456]86-*-go32) ;; # don't add gprof back in
552 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
553 esac
554 noconfigdirs="$noconfigdirs target-libgloss"
555 ;;
556 sparc-*-sunos4*)
557 if [ x${is_cross_compiler} != xno ] ; then
558 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
559 else
560 use_gnu_ld=no
561 fi
562 ;;
563 v810-*-*)
564 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
565 ;;
566 # start-sanitize-v850
567 v850-*-*)
568 noconfigdirs="$noconfigdirs target-libgloss"
569 ;;
570 # end-sanitize-v850
571 vax-*-vms)
572 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
573 ;;
574 vax-*-*)
575 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
576 ;;
577 *-*-lynxos*)
578 # Newlib makes problems for libg++ in crosses.
579 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
580 ;;
581 *-*-macos* | \
582 *-*-mpw*)
583 # Macs want a resource compiler.
584 configdirs="$configdirs grez"
585 ;;
586 esac
587
588 # targets that need a second pass
589 case "${target}" in
590 *-gm-magic*)
591 noconfigdirs="$noconfigdirs target-libgloss"
592 ;;
593 esac
594
595 # If we aren't building newlib, then don't build libgloss, since libgloss
596 # depends upon some newlib header files.
597 case "${noconfigdirs}" in
598 *target-libgloss*) ;;
599 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
600 esac
601
602 # If we are building a Canadian Cross, discard tools that can not be built
603 # using a cross compiler. FIXME: These tools should be fixed.
604 if [ "${build}" != "${host}" ]; then
605 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
606 fi
607
608 # Make sure we don't let GNU ld be added if we didn't want it.
609 if [ x$with_gnu_ld = xno ]; then
610 use_gnu_ld=no
611 noconfigdirs="$noconfigdirs ld"
612 fi
613
614 # Make sure we don't let GNU as be added if we didn't want it.
615 if [ x$with_gnu_as = xno ]; then
616 use_gnu_as=no
617 noconfigdirs="$noconfigdirs gas"
618 fi
619
620 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
621 # $target_configdirs.
622 # If we have the source for $noconfigdirs entries, add them to $notsupp.
623
624 notsupp=""
625 for dir in . $skipdirs $noconfigdirs ; do
626 dirname=`echo $dir | sed -e s/target-//g`
627 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
628 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
629 if [ -r $srcdir/$dirname/configure ] \
630 || [ -r $srcdir/$dirname/configure.in ]; then
631 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
632 true
633 else
634 notsupp="$notsupp $dir"
635 fi
636 fi
637 fi
638 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
639 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
640 if [ -r $srcdir/$dirname/configure ] \
641 || [ -r $srcdir/$dirname/configure.in ]; then
642 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
643 true
644 else
645 notsupp="$notsupp $dir"
646 fi
647 fi
648 fi
649 done
650
651 # Sometimes the tools are distributed with libiberty but with no other
652 # libraries. In that case, we don't want to build target-libiberty.
653 if [ -n "${target_configdirs}" ]; then
654 others=
655 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
656 if [ "$i" != "libiberty" ]; then
657 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
658 others=yes;
659 break;
660 fi
661 fi
662 done
663 if [ -z "${others}" ]; then
664 target_configdirs=
665 fi
666 fi
667
668 # Deconfigure all subdirectories, in case we are changing the
669 # configuration from one where a subdirectory is supported to one where it
670 # is not.
671 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
672 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
673 rm -f $i/Makefile
674 done
675 fi
676 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
677 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
678 rm -f ${target_subdir}/$i/Makefile
679 done
680 fi
681
682 # Produce a warning message for the subdirs we can't configure.
683 # This isn't especially interesting in the Cygnus tree, but in the individual
684 # FSF releases, it's important to let people know when their machine isn't
685 # supported by the one or two programs in a package.
686
687 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
688 # If $appdirs is non-empty, at least one of those directories must still
689 # be configured, or we error out. (E.g., if the gas release supports a
690 # specified target in some subdirs but not the gas subdir, we shouldn't
691 # pretend that all is well.)
692 if [ -n "$appdirs" ]; then
693 for dir in $appdirs ; do
694 if [ -r $dir/Makefile.in ]; then
695 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
696 appdirs=""
697 break
698 fi
699 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
700 appdirs=""
701 break
702 fi
703 fi
704 done
705 if [ -n "$appdirs" ]; then
706 echo "*** This configuration is not supported by this package." 1>&2
707 exit 1
708 fi
709 fi
710 # Okay, some application will build, or we don't care to check. Still
711 # notify of subdirs not getting built.
712 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
713 echo " ${notsupp}" 1>&2
714 echo " (Any other directories should still work fine.)" 1>&2
715 fi
716
717 # Set with_gnu_as and with_gnu_ld as appropriate.
718 #
719 # This is done by determining whether or not the appropriate directory
720 # is available, and by checking whether or not specific configurations
721 # have requested that this magic not happen.
722 #
723 # The command line options always override the explicit settings in
724 # configure.in, and the settings in configure.in override this magic.
725 #
726 # If the default for a toolchain is to use GNU as and ld, and you don't
727 # want to do that, then you should use the --without-gnu-as and
728 # --without-gnu-ld options for the configure script.
729
730 if [ x${use_gnu_as} = x ] ; then
731 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
732 with_gnu_as=yes
733 withoptions="$withoptions --with-gnu-as"
734 fi
735 fi
736
737 if [ x${use_gnu_ld} = x ] ; then
738 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
739 with_gnu_ld=yes
740 withoptions="$withoptions --with-gnu-ld"
741 fi
742 fi
743
744 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
745 # can detect this case.
746
747 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
748 with_newlib=yes
749 withoptions="$withoptions --with-newlib"
750 fi
751
752 if [ x${shared} = xyes ]; then
753 case "${target}" in
754 hppa*) target_makefile_frag=config/mt-papic ;;
755 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
756 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
757 esac
758 fi
759
760 # post-target:
761
762 # Make sure that the compiler is able to generate an executable. If it
763 # can't, we are probably in trouble. We don't care whether we can run the
764 # executable--we might be using a cross compiler--we only care whether it
765 # can be created. At this point the main configure script has set CC.
766 echo "int main () { return 0; }" > conftest.c
767 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
768 if [ $? = 0 ] && [ -s conftest ]; then
769 :
770 else
771 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
772 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
773 rm -f conftest*
774 exit 1
775 fi
776 rm -f conftest*
777
778 # The Solaris /usr/ucb/cc compiler does not appear to work.
779 case "${host}" in
780 sparc-sun-solaris2*)
781 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
782 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
783 could_use=
784 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
785 if [ -d /opt/cygnus/bin ] ; then
786 if [ "$could_use" = "" ] ; then
787 could_use="/opt/cygnus/bin"
788 else
789 could_use="$could_use or /opt/cygnus/bin"
790 fi
791 fi
792 if [ "$could_use" = "" ] ; then
793 echo "Warning: compilation may fail because you're using"
794 echo "/usr/ucb/cc. You should change your PATH or CC "
795 echo "variable and rerun configure."
796 else
797 echo "Warning: compilation may fail because you're using"
798 echo "/usr/ucb/cc, when you should use the C compiler from"
799 echo "$could_use. You should change your"
800 echo "PATH or CC variable and rerun configure."
801 fi
802 fi
803 ;;
804 esac
805
806 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
807 # binutils tools will find libbfd.so.
808 if [ "${shared}" = "yes" ]; then
809 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
810 Makefile > Makefile.tem
811 rm -f Makefile
812 mv -f Makefile.tem Makefile
813
814 case "${host}" in
815 *-*-hpux*)
816 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
817 Makefile > Makefile.tem
818 rm -f Makefile
819 mv -f Makefile.tem Makefile
820 ;;
821 esac
822 fi
823
824 # Record target_configdirs and the configure arguments in Makefile.
825 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
826 targargs=`echo "${arguments}" | \
827 sed -e 's/--norecursion//' \
828 -e 's/--cache[a-z-]*=[^ ]*//' \
829 -e 's/--ho[a-z-]*=[^ ]*//' \
830 -e 's/--ta[a-z-]*=[^ ]*//'`
831
832 # Passing a --with-cross-host argument lets the target libraries know
833 # whether they are being built with a cross-compiler or being built
834 # native. However, it would be better to use other mechanisms to make the
835 # sorts of decisions they want to make on this basis. Please consider
836 # this option to be deprecated. FIXME.
837 if [ x${is_cross_compiler} = xyes ]; then
838 targargs="--with-cross-host=${host_alias} ${targargs}"
839 fi
840
841 targargs="--host=${target_alias} ${targargs}"
842 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
843 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
844 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
845 Makefile > Makefile.tem
846 rm -f Makefile
847 mv -f Makefile.tem Makefile
848
849 #
850 # Local Variables:
851 # fill-column: 131
852 # End:
853 #